PRO fts_check_ramp_event, ev

   COMMON share1,x,ramp100,rampall,bad,rampflag,sname, xr, a, v, rctbl, sft
   COMMON share2,s1,s2,s3,s4,s5, ramp3,numpix,numramp,nump, ao, ramp2

	WIDGET_CONTROL, ev.ID, GET_UVALUE=uval
        
  CASE uval OF
    'ok': BEGIN
        ;ramp2=ramp3
        ;wrb = where(ramp2[*, *, 3] eq bad, nwrb)  
        ;if (nwrb ge 1 )then rampflag[wrb]=1
        ;wherenb=where(rampflag[6,*] eq 0,nnb)
        ;ramp3=ramp3[*,wherenb,*]
        ;x=x[*,indgen(nnb),*]
        rampflag[where(ramp3 eq bad)] = 1
        WIDGET_CONTROL, ev.TOP, /DESTROY
       END
    'plot'    : y_plot_ramp, x[*,*,s1-1], ramp3[*,*,s1-1], xtitle = 'sample number', ytitle = 'detector output [V]'
    'badramp' : BEGIN
        if (ao eq 0) then ramp3[*,s2:s3,*]=bad $
        else if (ao eq 1) then ramp3[*, s2:s3, s1-1] = bad
       END
    'badpoint': BEGIN
         if (ao eq 0) then ramp3[s4:s5, *, *] = bad $
         else if (ao eq 1) then ramp3[s4:s5, *, s1-1] = bad
      END
    'save_flag'      :BEGIN
        rampflag[where (ramp3 eq bad)] = 1
        ramp2 = ramp3
        ;wrb = where(ramp2[*, *, 3] eq bad, nwrb)  
        ;if (nwrb ge 1 )then rampflag[wrb]=1
      END
    'reset'   :BEGIN
       ramp3=ramp2
        ;ramp3[where (rampflag eq 1)] = bad
      END
    'allch'   : ao = 0
    'onech'   : ao = 1

    'SLIDE1':BEGIN
  	WIDGET_CONTROL, ev.ID, GET_VALUE = s1
  	y_plot_ramp, x[*,*,s1-1], ramp3[*,*,s1-1], xtitle = 'sample number', ytitle = 'detector output [V]'
      END
    'SLIDE2':BEGIN
        WIDGET_CONTROL, ev.ID, GET_VALUE = s2
	   oplot, x[*,s2,s1-1], ramp3[*,s2,s1-1], symsize=0.5, psym=2,color='0000FF'XL
      END
    'SLIDE3':BEGIN
        WIDGET_CONTROL, ev.ID, GET_VALUE = s3
        oplot, x[*,s3,s1-1], ramp3[*,s3,s1-1],symsize=0.5, psym=2,color='FF00FF'XL
      END
    'SLIDE4':BEGIN
        WIDGET_CONTROL, ev.ID, GET_VALUE = s4
        oplot, x[s4,*,s1-1], ramp3[s4,*,s1-1],symsize=0.5, psym=2,color='FF0000'XL
      END
    'SLIDE5':BEGIN
  	WIDGET_CONTROL, ev.ID, GET_VALUE = s5
	oplot, x[s5,*,s1-1], ramp3[s5,*,s1-1],symsize=0.5, psym=2,color='00FF00'XL
      END


  ENDCASE
END

PRO fts_check_ramp, rampbflg=rampbflg ;

   COMMON share1,x,ramp100,rampall,bad,rampflag,sname, xr, a, v, rctbl, sft
   COMMON share2,s1,s2,s3,s4,s5, ramp3,numpix,numramp,nump, ao, ramp2
   COMMON share_name,filename0,addname0, newname

	s1=31S
	s2=0S
	s3=0S
	s4=0S
	s5=0S
        ao = 0
     ramp3=ramp100

	base = WIDGET_BASE(TITLE = 'check_ramp: '+filename0, $
          /ROW,XSIZE=700,YSIZE=550)
	baseL=WIDGET_BASE(base, /column, XSIZE=400,YSIZE=550)
	Draw = Widget_Draw(BaseL , XOFFSET=5 ,YOFFSET=20  $
      ,SCR_XSIZE=380 ,SCR_YSIZE=300)
      
	baseR=WIDGET_BASE(base, /column,Xsize=250,ysize=550)
	button1 = WIDGET_BUTTON(baseR, VALUE='plot', UVALUE='plot')

	;get number of data
	si=SIZE(x)
	numpix=si[3]*3/5
	numramp=si[2]
        nump=si[1]
        rampflag=intarr(nump,numramp, numpix)

        if (keyword_set(rampbflg) eq 1) then begin   
           restore,rampbflg  
           ;ramp3=reform(ramp3,nump*numramp,numpix)
           ramp3[where(rampflag eq 1)]= bad
        endif
        ramp2 = ramp3
       
	;slider ch
	slider1 = WIDGET_SLIDER(baseL,	MINIMUM = 1, MAXIMUM = numpix, $
		  TITLE = 'channel', /FRAME, UVALUE = 'SLIDE1',VALUE=s1,XSIZE = 100)
        baseLB=WIDGET_BASE(baseL,/column, /EXCLUSIVE, XOFFSET=15)
        allbutton = WIDGET_BUTTON(baseLB,VALUE='all channel', UVALUE='allch', /NO_RELEASE)
	onebutton = WIDGET_BUTTON(baseLB,VALUE='one channel', UVALUE='onech', /NO_RELEASE)

	;slider ramp

        sliderramptitle = WIDGET_LABEL(baseR, VALUE = 'ramp curve range', yoffset = 10)
	slider2 = WIDGET_SLIDER(baseR, MINIMUM = 0, MAXIMUM = numramp-1, $
		  TITLE = 'minimum', /FRAME, UVALUE = 'SLIDE2',VALUE=s2,XSIZE = 150)
	slider3 = WIDGET_SLIDER(baseR, MINIMUM = 0, MAXIMUM = numramp-1, $
		  TITLE = 'maximum', /FRAME, UVALUE = 'SLIDE3',VALUE=s3,XSIZE = 150)

	button3 = WIDGET_BUTTON(baseR, value='mask ramp curve', UVALUE='badramp')

	;slider point
        sliderpointtitle = WIDGET_LABEL(baseR, VALUE = 'sample number range', yoffset = 10)
	slider4 = WIDGET_SLIDER(baseR, MINIMUM = 0, MAXIMUM = nump-1, $
		  TITLE = 'minimum', /FRAME, UVALUE = 'SLIDE4',VALUE=s4,XSIZE = 80)
	slider5 = WIDGET_SLIDER(baseR, MINIMUM = 0, MAXIMUM = nump-1, $
		  TITLE = 'maximum', /FRAME, UVALUE = 'SLIDE5',VALUE=s5,XSIZE = 80)
	button4 = WIDGET_BUTTON(baseR, value='mask sample number', UVALUE='badpoint')

	button5 = WIDGET_BUTTON(baseR, value='save flag', UVALUE='save_flag', yoffset = 10)
	button6 = WIDGET_BUTTON(baseR, value='reset', UVALUE='reset')
	button2 = WIDGET_BUTTON(baseR, value='ok', UVALUE='ok')

      WIDGET_CONTROL, allbutton, /SET_BUTTON
      WIDGET_CONTROL, base, /REALIZE
  
   XMANAGER, 'fts_check_ramp', base

END
