PRO fts_check_rampcorr_event, ev

  COMMON share_plotd,draw,draw1,draw2, s1,rg1
  COMMON share_n, ndata,ndrv,ndet,datatype,pktid_f,pch,ver,rstext,quitflg
  COMMON share_dif,pdif,pflux,px,pseki,ppsym
  COMMON groupleader, base0
  COMMON rgip,rgip0,rgip1,rgip2,rgip3, rgip4,rgip5
  COMMON share1,x,ramp100,rampall,bad,rampflag,sname, xr, a, v, rctbl

  WIDGET_CONTROL, ev.ID, GET_UVALUE=uval	

  CASE uval OF
    'quit':BEGIN
         quitflg = 1
         WIDGET_CONTROL, ev.TOP, /DESTROY
       END
    'ok':WIDGET_CONTROL,ev.TOP, /DESTROY 

    'range':BEGIN
	pbase = WIDGET_BASE(row=4,tab_mode=1,XSIZE=400, YSIZE=150)
	pbaseu=WIDGET_BASE(pbase, /row)
	pbasem=WIDGET_BASE(pbase, /row)
	pbasem2=WIDGET_BASE(pbase, /row)
	pbaseb=WIDGET_BASE(pbase,/align_center)

	rglab0 = WIDGET_LABEL(pbaseu, VALUE = 'xrange        (',xsize=100)
	rgip0 = WIDGET_TEXT(pbaseu,/EDITABLE,XSIZE = 15, YSIZE = 1,$
		  value=string(rg1[0]),uvalue='rangeok' )
	rglab1 = WIDGET_LABEL(pbaseu, VALUE = ' ,',xsize=10)
	rgip1 = WIDGET_TEXT(pbaseu,/EDITABLE,XSIZE = 15, YSIZE = 1,$
		 value=string(rg1[1]),uvalue='rangeok')
	rglab2 = WIDGET_LABEL(pbaseu, VALUE = ')',xsize=20)

	rglab3 = WIDGET_LABEL(pbasem, VALUE = 'yrange (upper) (',xsize=100)
	rgip2 = WIDGET_TEXT(pbasem,/EDITABLE,XSIZE = 15, YSIZE = 1,$
		 value=string(rg1[2]),uvalue='rangeok')
	rglab4 = WIDGET_LABEL(pbasem, VALUE = ' ,',xsize=10)
	rgip3 = WIDGET_TEXT(pbasem, /EDITABLE, XSIZE =15, YSIZE = 1,$
		 value=string(rg1[3]),uvalue='rangeok')
	rglab5 = WIDGET_LABEL(pbasem, VALUE = ')',xsize=20)

	rglab6 = WIDGET_LABEL(pbasem2, VALUE = 'yrange (lower) (',xsize=100)
	rgip4 = WIDGET_TEXT(pbasem2,/EDITABLE,XSIZE = 15, YSIZE = 1,$
		 value=string(rg1[4]),uvalue='rangeok')
	rglab7 = WIDGET_LABEL(pbasem2, VALUE = ' ,',xsize=10)
	rgip5 = WIDGET_TEXT(pbasem2, /EDITABLE, XSIZE =15, YSIZE = 1,$
		 value=string(rg1[5]),uvalue='rangeok')
	rglab8 = WIDGET_LABEL(pbasem2, VALUE = ')',xsize=20)


	popupbutton = WIDGET_BUTTON(pbaseb, /align_center,$
                  UVALUE = 'rangeok',VALUE = 'OK', XSIZE=30, YSIZE=20)
	WIDGET_CONTROL, base0, SENSITIVE=0
        WIDGET_CONTROL, pbase, /REALIZE
	XMANAGER, "fts_check_rampcorr", pbase, GROUP_LEADER=base0, /NO_BLOCK
     END

     'rangeok': BEGIN
	WIDGET_CONTROL, rgip0, GET_VALUE = aaa0
	WIDGET_CONTROL, rgip1, GET_VALUE = aaa1
	WIDGET_CONTROL, rgip2, GET_VALUE = aaa2
	WIDGET_CONTROL, rgip3, GET_VALUE = aaa3
	WIDGET_CONTROL, rgip4, GET_VALUE = aaa4
	WIDGET_CONTROL, rgip5, GET_VALUE = aaa5

	rg1=[aaa0[0],aaa1[0],aaa2[0],aaa3[0], aaa4[0], aaa5[0]]
	WIDGET_CONTROL, ev.top, /DESTROY
        WIDGET_CONTROL, base0, SENSITIVE=1
	mirudifplot
      END

     'SLIDE1':BEGIN
        WIDGET_CONTROL, ev.ID, GET_VALUE = s1
	mirudifplot
      END

  ENDCASE
END


PRO mirudifplot
  COMMON share_plotd,draw,draw1,draw2, s1,rg1
  COMMON share_n, ndata,ndrv,ndet,datatype,pktid_f,pch,ver,rstext,quitflg
  COMMON share_dif,pdif,pflux,px,pseki,ppsym
  COMMON share1,x,ramp100,rampall,bad,rampflag,sname, xr, a, v, rctbl

  WIDGET_CONTROL, draw, GET_VALUE=fig1
  WIDGET_CONTROL, draw1, GET_VALUE=fig2  
  WIDGET_CONTROL, draw2, GET_VALUE=fig3  
	
  Wset,fig1
  plot, px, pdif[s1-1,*],xrange=[rg1[0],rg1[1]],yrange=[rg1[2],rg1[3]],psym=ppsym, xtitle = 'sample number', ytitle = 'interferogram [V/s]'
  oplot,px, pflux[s1-1,*],color='FF0000'XL,psym=ppsym

  Wset,fig2
  ymin=min(pseki[s1-1,*])
  ymax=max(pseki[s1-1,*])
  plot, px, pseki[s1-1,*],xrange=[rg1[0],rg1[1]],yrange=[rg1[4],rg1[5]],$
    psym=ppsym, ticklen = 1.0, xgridstyle = 1, ygridstyle = 1, $
    xtitle = 'sample number', ytitle = 'detector output [V]'


  Wset, fig3
  if (n_elements(xr) gt 0) then begin
     y_plot_ramp, x[*,*,s1-1], v[*,*,s1-1],yrange=[rg1[4],rg1[5]], $
      ticklen = 1.0, xgridstyle = 1, ygridstyle = 1
     oplot,xr[*,*,s1-1], a[*,*,s1-1],color='FF00FF'XL,psym=-2
     oplot,xr[*,*,s1-1], rctbl[s1-1].V,psym=-2, color = 'FFFF00'XL
     oplot,xr[*,*,s1-1], rctbl[s1-1].V+rctbl[s1-1].C,color='00FFFF'XL,psym=-2
   endif else if (n_elements(rctbl) gt 0) then begin
     plot, rctbl[s1-1].V, psym = -2, yrange = [rg1[4], rg1[5]], $
      ticklen = 1.0, xgridstyle = 1, ygridstyle = 1
     oplot, rctbl[s1-1].V+rctbl[s1-1].C,color='FF00FF'XL,psym=-2
   endif
END


PRO fts_check_rampcorr,dif,flux,seki,psym,nopara=nopara

  COMMON share_plotd,draw,draw1,draw2, s1,rg1
  COMMON share_n, ndata,ndrv,ndet,datatype,pktid_f,pch,ver,rstext,quitflg
  COMMON share_dif,pdif,pflux,px,pseki,ppsym
  COMMON groupleader, base0
  COMMON share_h, heads,tmprlcb,cb
  COMMON share1,x,ramp100,rampall,bad,rampflag,sname, xr, a, v, rctbl
   COMMON share_name,filename0,addname0, newname

  pdif=dif
  pflux=flux
  pseki=seki
  ppsym=psym

  s1=1
  if (keyword_set(nopara) eq 1) then begin
    ssize=size(flux)
    ndet=ssize[1]	
    tmprlcb=500
  endif

  fluxsize=size(flux)
  px=indgen(fluxsize[2],/long)
 ; rg1=[tmprlcb[0]-100,tmprlcb[0]+100, 0, 0.1]
  rg1=[tmprlcb[0]-100,tmprlcb[0]+100, 0, 0.1, 0, 0.1]

  base0= WIDGET_BASE(TITLE = 'check_ramp_curve_corr:'+filename0, $
           /column,XSIZE=1000,YSIZE=600)
    baseT = WIDGET_BASE(base0,XSIZE=1000,YSIZE=270)
;      label= WIDGET_LABEL(baseT,VALUE = 'blue:corrected')
      Draw = Widget_Draw(baseT ,XOFFSET=5 ,YOFFSET=20,XSIZE=700 ,YSIZE=260)

    baseM = WIDGET_BASE(base0,/row, XSIZE=1000,YSIZE=270)
      Draw1= Widget_Draw(baseM ,XOFFSET=5 ,YOFFSET=20,XSIZE=700 ,YSIZE=260)
      Draw2= Widget_Draw(baseM ,XOFFSET=5 ,YOFFSET=20,XSIZE=290 ,YSIZE=260)
        
    baseB= WIDGET_BASE(base0,/row,XSIZE=1000,YSIZE=50)
	button2 = WIDGET_BUTTON(baseB, value='ok', UVALUE='ok')
	button3 = WIDGET_BUTTON(baseB, value='range', UVALUE='range')
        button4 = WIDGET_BUTTON(baseB, value='quit',UVALUE='quit')
	slider1 = WIDGET_SLIDER(baseB,MINIMUM = 1, MAXIMUM = ndet, $
		  TITLE = 'channel', /FRAME, UVALUE = 'SLIDE1',VALUE=s1,XSIZE = 150)

  WIDGET_CONTROL, base0, /REALIZE
  XMANAGER, 'fts_check_rampcorr', base0, GROUP_LEADER=GROUP;, ;/NO_BLOCK

END
