PRO fts_check_resetbad_event, ev

  COMMON share_plotv,draw,s1,s2,s3,s4,s5,rg1
  COMMON share_n, ndata,ndrv,ndet,datatype,pktid_f,pch,ver,rstext,quitflg
  COMMON groupleader, base0
  COMMON rgip,rgip0,rgip1,rgip2,rgip3
  COMMON share_if,vif,vifpos,vif2,vifbad
  COMMON share_rstok,reok

  WIDGET_CONTROL, ev.ID, GET_UVALUE=uval	

  CASE uval OF
    'ok': BEGIN
        reok=1
        WIDGET_CONTROL, ev.TOP, /DESTROY
    END

    'do_again': BEGIN
        print,'rstext=',rstext
        WIDGET_CONTROL, ev.TOP, /DESTROY
    END

    'range':BEGIN
	pbase = WIDGET_BASE(row=3,tab_mode=1,XSIZE=300, YSIZE=100)
	pbaseu=WIDGET_BASE(pbase, /row)
	pbasem=WIDGET_BASE(pbase, /row)
	pbaseb=WIDGET_BASE(pbase,/align_center)
	rglab0 = WIDGET_LABEL(pbaseu, VALUE = 'xrange (',xsize=50)
	rgip0 = WIDGET_TEXT(pbaseu,/EDITABLE,XSIZE = 15, YSIZE = 1,$
		  value=string(rg1[0]),uvalue='rangeok' )
	rglab1 = WIDGET_LABEL(pbaseu, VALUE = ' ,',xsize=10)
	rgip1 = WIDGET_TEXT(pbaseu,/EDITABLE,XSIZE = 15, YSIZE = 1,$
		 value=string(rg1[1]),uvalue='rangeok')
	rglab2 = WIDGET_LABEL(pbaseu, VALUE = ')',xsize=20)
	rglab3 = WIDGET_LABEL(pbasem, VALUE = 'yrange (',xsize=50)
	rgip2 = WIDGET_TEXT(pbasem,/EDITABLE,XSIZE = 15, YSIZE = 1,$
		 value=string(rg1[2]),uvalue='rangeok')
	rglab4 = WIDGET_LABEL(pbasem, VALUE = ' ,',xsize=10)
	rgip3 = WIDGET_TEXT(pbasem, /EDITABLE, XSIZE =15, YSIZE = 1,$
		 value=string(rg1[3]),uvalue='rangeok')
	rglab5 = WIDGET_LABEL(pbasem, VALUE = ')',xsize=20)
	popupbutton = WIDGET_BUTTON(pbaseb, /align_center,$
                  UVALUE = 'rangeok',VALUE = 'OK', XSIZE=30, YSIZE=20)
	WIDGET_CONTROL, base0, SENSITIVE=0
		  WIDGET_CONTROL, pbase, /REALIZE
			XMANAGER, "fts_check_resetbad", pbase, GROUP_LEADER=base0, $
			          /NO_BLOCK
     END

     'rangeok': BEGIN
	WIDGET_CONTROL, rgip0, GET_VALUE = aaa0
	WIDGET_CONTROL, rgip1, GET_VALUE = aaa1
	WIDGET_CONTROL, rgip2, GET_VALUE = aaa2
	WIDGET_CONTROL, rgip3, GET_VALUE = aaa3
	rg1=[aaa0[0],aaa1[0],aaa2[0],aaa3[0]]
	WIDGET_CONTROL, ev.top, /DESTROY
        WIDGET_CONTROL, base0, SENSITIVE=1
	miruvifplot
      END

     'SLIDE1':BEGIN
        WIDGET_CONTROL, ev.ID, GET_VALUE = s1
	miruvifplot
      END

     'SLIDE2':BEGIN
        WIDGET_CONTROL, ev.ID, GET_VALUE = s2
        if (s2 le s3) then miruvifplot 
      END

     'SLIDE3':BEGIN
        WIDGET_CONTROL, ev.ID, GET_VALUE = s3
        if (s2 le s3) then miruvifplot
      END

     'SLIDE4':BEGIN
        WIDGET_CONTROL, ev.ID, GET_VALUE = s4
        rstext[0]=s4
      END

     'SLIDE5':BEGIN
        WIDGET_CONTROL, ev.ID, GET_VALUE = s5
        rstext[1]=s5
      END


  ENDCASE
END


PRO miruvifplot
  COMMON share_plotv,draw,s1,s2,s3,s4,s5,rg1
  COMMON share_n, ndata,ndrv,ndet,datatype,pktid_f,pch,ver,rstext,quitflg
  COMMON share_if,vif,vifpos,vif2,vifbad
  COMMON share_rstok,reok

  WIDGET_CONTROL, draw, GET_VALUE=fig1   
	
  Wset,fig1
  plot, vif2[*,s2,s1-1],xrange=[rg1[0],rg1[1]],yrange=[rg1[2],rg1[3]],psym=-2, xtitle = 'sample number', ytitle = 'interferogram [V/s]'
  if (s3 gt s2) then begin
    for ndv=s2+1, s3 do begin
       oplot,vif2[*,ndv,s1-1],psym=-2
    endfor 
  endif 
END


PRO fts_check_resetbad

  COMMON share_plotv,draw,s1,s2,s3,s4,s5,rg1
  COMMON share_n, ndata,ndrv,ndet,datatype,pktid_f,pch,ver,rstext,quitflg
  COMMON groupleader, base0
  COMMON share_if,vif,vifpos,vif2,vifbad
  COMMON share_rstok,reok
  COMMON share_name,filename0,addname0, newname
 
  s1=1
  s2=0
  s3=0
  s4=rstext[0]
  s5=rstext[1]
  rg1=[0,ndata-1, 0, 1]

  base0 = WIDGET_BASE(TITLE = 'check_reset_bad: '+filename0, $
                      /column, XSIZE = 1000, YSIZE = 500)
    baseT = WIDGET_BASE(base0,XSIZE=980,YSIZE=400)
;      label= WIDGET_LABEL(baseT,VALUE = 'vif')
      Draw = Widget_Draw(baseT ,XOFFSET=5 ,YOFFSET=20,XSIZE=980 ,YSIZE=350)
  
    baseB= WIDGET_BASE(base0,column = 3,XSIZE=950,YSIZE=100)
      baseB1 = WIDGET_BASE(baseB, /column)
      baseB2 = WIDGET_BASE(baseB, /column)
      baseB3 = WIDGET_BASE(baseB, /column)

      baseB1u = WIDGET_BASE(baseB1)
      baseB1b = WIDGET_BASE(baseB1, /row)
      baseB2u = WIDGET_BASE(baseB2)
      baseB2b = WIDGET_BASE(baseB2, /row)
      baseB3u = WIDGET_BASE(baseB3)
      baseB3b = WIDGET_BASE(baseB3, /row)

      dummy = WIDGET_LABEL(baseB1u, VALUE = ' ')
      button1 = WIDGET_BUTTON(baseB1b, value='ok', UVALUE='ok')
      button2 = WIDGET_BUTTON(baseB1b, value='do_again', UVALUE='do_again')
      button3 = WIDGET_BUTTON(baseB1b, value='range', UVALUE='range')

      slider1 = WIDGET_SLIDER(baseB1b,MINIMUM = 1, MAXIMUM = ndet, $
	  TITLE = 'channel', /FRAME, UVALUE = 'SLIDE1',VALUE=s1,XSIZE = 150)

      labelb2b = WIDGET_LABEL(baseB2u, VALUE = 'plot scan range')
      slider2 = WIDGET_SLIDER(baseB2b,MINIMUM = 0, MAXIMUM = ndrv-1, $
	  TITLE = 'minimum', /FRAME, UVALUE = 'SLIDE2',VALUE=s2,XSIZE = 150)
      slider3 = WIDGET_SLIDER(baseB2b,MINIMUM = 0, MAXIMUM = ndrv-1, $
	  TITLE = 'maximum', /FRAME, UVALUE = 'SLIDE3',VALUE=s3,XSIZE = 150)

      labelb2b = WIDGET_LABEL(baseB3u, VALUE = 'reset anomaly range')
      slider4 = WIDGET_SLIDER(baseB3b,MINIMUM = -5, MAXIMUM = 0, $
	  TITLE = 'before reset', /FRAME, UVALUE = 'SLIDE4',VALUE=s4,XSIZE = 100)
      slider5 = WIDGET_SLIDER(baseB3b,MINIMUM = 1, MAXIMUM = 5, $
	  TITLE = 'after reset', /FRAME, UVALUE = 'SLIDE5',VALUE=s5,XSIZE = 100)

  WIDGET_CONTROL, base0, /REALIZE
  XMANAGER, 'fts_check_resetbad', base0, GROUP_LEADER=GROUP;, ;/NO_BLOCK

END
