PRO fts_drvheads,	$
	tsd	,		$	;TSD data
	pktid,$
	mcal,$
        ncantuse, $
	tiskip,$
        stati, $
	fpi2=fpi2

COMMON share_n, ndata,ndrv,ndet,datatype,pktid_f,pch,ver,rstext,quitflg
COMMON share_h, heads,tmprlcb,cb

fisti=tsd->Get_value_TSD('FIS_OBS','FISTI')
blank=tsd->Get_flag_TSD('FIS_OBS','blank')
mpos=tsd->Get_value_TSD('FIS_OBS','MPOSCNT')

;;;;;;;;;;;;;; no stati ;;;;;;;;;;;;;

if (n_elements(stati) eq 0) then begin

   sfpktid=shift(pktid,1)
   shifti=shift(fisti,1)
   si = SIZE(fisti)
   num=si[1]

   ;;;;; set start point ;;;;;;;;;;;;;;;;;;;;

   ;;;;;;;;;;;;;;; no tiskip (LDS data) ;;;;;;;;;;;;;;;;; 
 
   if (n_elements(tiskip) eq 0) then begin
      start=where ((blank eq 0) and (shift(blank,1) eq 1))
 
      if (n_elements(start) gt 1) then begin
         print, 'start = ',start
         !p.multi = [0, 1, 2]
         plot, mpos
         plot, blank
         !p.multi = 0
         read, whst, prompt='which is a true start point? 0 or 1: ' 
         start = start[whst]
       endif else $
      if (start eq -1) then begin 
         start = 0 
         print, 'Start point is set to 0 if /tiskip is not set and there is no point of blank flag = 1.'
       endif

      pktid_f=pktid[start[0]+2]        
      print,'tiskip=0'
    endif $

   ;;;;;;;;;;;;;;; tiskip = 1 ;;;;;;;;;;;;;;;;;;;;;

   else if (tiskip eq 1) then begin
      tobitobi=where(((fisti-shifti) gt 50),ntobi)
      start=tobitobi[0]+1
      pktid_f=pktid[start]
      print,'tiskip=1'
      if (tobitobi[0] eq 0) then print,$
        'Start point is set to 0 if /tiskip is not set and there is no point of blank flag = 1.'
    endif $
    
   ;;;;;;;;;;;;;; tiskip = 2(see part1.memmo) ;;;;;;;;;;;;;;;;;;;;;;;

   else if (tiskip eq 2) then begin
      pktid_f = pktid[1000]   
      if ((datatype eq 'FIS_LW') and (pktid_f eq 14)) then begin
         orec = [2225, 2396, 2399]
         nnn = [3, 2048]
       endif else $
      if ((datatype eq 'FIS_LW') and (pktid_f eq 124)) then begin
         orec = [1201,1372, 1375]
         nnn = [3, 1024]
       endif else $
      if ((datatype eq 'FIS_SW') and (pktid_f eq 14)) then begin
         orec = [4450, 4792, 4798]
         nnn = [3, 4096]
       endif else $
      if ((datatype eq 'FIS_SW') and (pktid_f eq 124)) then begin
         orec = [2402, 2744, 2750]
         nnn = [3, 2048]
       endif

      oref = intarr(nnn[0])
      for nn = 0, nnn[0]-1 do begin
         k = orec[nn]
         if ((mpos[k+1]-mpos[k])*(mpos[k-1]-mpos[k-2]) le 0) then oref[nn]=1
        endfor 
 
      if (n_elements( where(oref eq 1) ) gt 1) then begin
          w = indgen(orec[nnn[0]-1]-orec[0]+10)+orec[0]-5
          plot,w, mpos[w], ystyle = 1
          ww = indgen(nnn[0])
          oplot, orec[ww], mpos[orec[ww]],psym = 2, color = 'FFFF00'XL
          print, ww, orec[ww]       
          read, whst, prompt='which is a true start point? : ' 
          start = orec[oref[whst]]-nnn[1]
        endif else $
      if ( where(oref eq 1)  eq -1 )then begin
         print,'check mpos data!' 
         stop
       endif else start = orec[where (oref eq 1)]-nnn[1]
    endif

   ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;   if (pktid_f eq 124) then drvti=16384L ;;;(=$7C SED)
;   if (pktid_f eq 14) then drvti=16384*4L ;;;(=$0E fullreso)
;   if (pktid_f eq 124) then qua=0
;   if (pktid_f eq 14) then qua=drvti/4

;   stati=fisti[start[0]]+qua
;   print, 'stati = ', stati, 'qua=', qua
;   start=where(fisti eq stati)+1

   if (pktid_f eq 124) then begin ;;;(=$7C SED)
      if (datatype eq 'FIS_LW') then drvn = 2048 $
      else if (datatype eq 'FIS_SW') then drvn = 4096
      qua = 0
    endif else $
   if (pktid_f eq 14) then begin  ;;;(=$0E fullreso)
      if (datatype eq 'FIS_LW') then drvn = 8192 $
      else if (datatype eq 'FIS_SW') then drvn = 16384
       qua=drvn/4
     endif

   start=start[0]+qua
   stati = fisti[start]

   print,format='(%"pktid=$%x%s.")',pktid_f
   print,'start=',start,'stati=',stati
   print,'ncantuse=',ncantuse

   ;heads : starting ptisions of each drive
   heads=lindgen(50)*drvn+start+1
   q = where (heads gt num-drvn)
   jcnt = q[0] 
   print, q
   heads = heads[0:jcnt-1]
;   j=1
;   for i=start[0]+1, num-1 do begin
;      if ((shifti[i] LT (stati+j*drvti)) and $
;         (fisti[i] GE (stati+j*drvti))) then begin
;	 heads[j]=i
;	j++
;      endif
;    endfor
;   jcnt=j-1

endif $

;;;;;;;;;;;;;;;;; stati ;;;;;;;;;;;;;;;;;;;;;

else begin
  startti=stati
  pktid_f=pktid[0]
  print,format='(%"pktid=$%x%s.")',pktid_f

  ;drvti = time / 1 drive (fisti)
  if(pktid_f eq 124) then drvti=16384L ;;$7c SED
  if(pktid_f eq 14) then drvti=16384*4L ;;$0e fullreso
  if(pktid_f eq 123) then drvti=16384L ;;$7b SED 5line mode  at fec7

  ;set start
  tobi=ceil((fisti[0]-startti)/drvti)
  shifti=shift(fisti,1)
  if (pktid_f eq 124) then qua=0
  if (pktid_f eq 14) then qua=drvti/4
  if (pktid_f eq 123) then qua=0

  start=where((fisti GE (startti+(tobi+1)*drvti+qua))$
	   and	(shifti LT (startti+(tobi+1)*drvti+qua)))

  print,'start=',start
  ;heads : starting ptisions of each drive
  heads=lonarr(50)
  j=0
  for i=start[0], num-1 do begin
	if ((shifti[i] LT (startti+(j+tobi+1)*drvti+qua)) and $
  		 (fisti[i] GE (startti+(j+tobi+1)*drvti+qua)))	 then begin
		heads[j]=i
		print,j
		j++
	endif

  endfor
  jcnt=j-1
  heads = heads[0:jcnt-1]
endelse


;;;;;;;;;;;;;1&2

;;;; mcal 
if (n_elements(mcal) ge 1) then begin
  heads=heads[7:jcnt-1]
  jcnt=jcnt-7-1
endif

ndrv=jcnt
ndata=heads[1]-heads[0]
ndata=ndata/2*2
print,'ndata=', ndata

print,'heads=',heads


tmprlcb=lonarr(2,jcnt)

if (datatype eq 'FIS_LW' and pktid_f eq 124) then begin
	cb=[512+5,1536+17]
endif else if (datatype eq 'FIS_LW' and pktid_f eq 14) then begin
	cb=[1021,3069]
endif else if (datatype eq 'FIS_SW' and pktid_f eq 124) then begin
	cb=[1024+10,3072+34]
endif else if  (datatype eq 'FIS_SW' and pktid_f eq 14) then begin
	cb=[2042,6138]
endif else if (pktid[start] eq 123) then begin
	cb=[512+5,1536+17]
      endif


if ((keyword_set(fpi2) eq 1) and (datatype eq 'FIS_LW'))$
 then 	cb=[cb[0]-432,cb[1]+1015]
if((keyword_set(fpi2) eq 1) and (datatype eq 'FIS_SW'))$
  then 	cb=[cb[0]+20,cb[1]]


for j=0,jcnt-1 do begin
	tmprlcb[0,j]=heads[j]+cb[0]
	tmprlcb[1,j]=heads[j]+cb[1]
endfor

tmprlcb2=reform(tmprlcb,2*jcnt)



MESSAGE,'FINISH.',/continue

END
