PRO fts_makerctbl, $
  tsd,	$;
  ncantuse, $
  boxcar,$
  savname3,$
  pixflg, $
  extra_x, $
  rampbflg=rampbflg	

COMMON share_n, ndata,ndrv,ndet,datatype,pktid_f,pch,ver,rstext,quitflg
COMMON share_h, heads,tmprlcb,cb
COMMON share_name,filename0,addname0, newname


name=newname+'_ramp'
savname=name+'.sav'
savname2=name+'tbl.sav'
savname3=name+'tbl.ccf'

cvsroot = GETENV('FISDR_ROOT')

fts_make_range,tsd,range,ncantuse
COMMON share1,x,ramp100,rampall,bad,rampflag,sname, xr, a, v, rctbl, sft
sname=name+'flg.sav'

  fts_rconv2,tsd,range
  help,rampall

if (datatype eq 'FIS_SW') then badpi=[0,10,indgen(40)+60] $
 else badpi=[1,2,17,32,41,indgen(30)+45]

rampall[*,*,badpi]=bad
if (n_elements(pixflg) ge 1) then rampall[*, *, pixflg-1] = bad

rsize = size(rampall)
if (rsize[2] gt 100) then  begin
   ramp100 = rampall[*, 0:99, *]
   for p = 0, rsize[3]*3/5 do begin
      rsort =reverse( sort(rampall[rsize[1]-3, *, p]))
      ramp100[*, *, p] = rampall[*, rsort[0:99], p]
   endfor
endif

x = y_xidx(ramp100)

if (keyword_set(rampbflg)) then fts_check_ramp,rampbflg=rampbflg $
 else  fts_check_ramp

ramp = ramp100
ramp[where(rampflag eq 1)] = bad

if (rsize[1] eq 12) then swidth = 10 else $
if (rsize[1] eq 24) then swidth = 20 else $
if (rsize[1] eq 48) then swidth = 30 else $
if (rsize[1] eq 96) then swidth = 50 else $
if (rsize[1] eq 192) then swidth = 50 else begin
  print, 'rsize[1]=', rsize[1]
  stop
endelse
print,  'swidth=', swidth

y_eval_ramp_curve, name, ramp=ramp, /NOOUTOFRANGE,/NONSFIT,/NOSTAT,$
       EXTRA_X=extra_x,  SWIDTH=swidth 
fts_check_y_eval_ramp_corr, savname, extra_x = extra_x

restore,savname

if (datatype eq 'FIS_SW') then $
  yrngfile = cvsroot+'/fts/fts_part1/data/corr_tbl_yrng_SW.sav' $
else if (datatype eq 'FIS_LW') then $
  yrngfile = cvsroot+'/fts/fts_part1/data/corr_tbl_yrng_LW.sav' 

 rctbl = y_make_corr_tbl(a, PCEF=p, boxcar=1,ccf=savname3, /PLOT, extyrngfile = yrngfile)

  ;; add rampflag,rctbl,and rampall to '~.sav' file
  
  if (n_elements(yd) gt 0) then begin
    save,v, x, dx, fx, xo, yd, ye, xr, a, s, t,rampflag,rctbl,$
             rampall, filename=savname
    print,'save yd rampflag'
  endif
  if (n_elements(yd) eq 0) then begin
    save, v, x, dx, fx, a, xr, s, t,rampflag,rctbl,rampall,filename=savname
    print,'save rampflag'
  endif

  fts_check_ramprange, a, datatype, pixflg

;  rctbl = y_make_corr_tbl(a, range=[1, 45], PCEF=p, boxcar=1, /PLOT)
;   rctbl = y_make_corr_tbl(a, PCEF=p, boxcar=1,ccf=savname3, /PLOT) 


MESSAGE,'FINISH.',/continue
end
