;#> frin_plot_part.dc1
; Identifier	frin_plot_part
;
; Purpose	plot routienfor frin_plot_total and frin_plot_result
;
; Synopsis	frin_plot_part, wn, xx, wt, pl, _extra=_extra
;
; Arguments	Name	I/O    Type:	Description
;		------------------------------------------------------------
;		wn	 I     struct
;		xx	 I     struct
;		wt	 I     struct
;		pl	 I     struct
;		_extra	 I     struct
;
; Returns	--
;
; Description
;
;
;
;
; Comment
;
;
; Example	--
;
; Category	UTIL ( module: frin_plot_part )
;
; Filename	frin_plot_part.pro
;
; Author	Do Kester
;
; Version	1.1
;
; History	1.0  21-03-2001 DK, first implementation of frin_plot_part.pro
;		1.1  05-04-2001 DK, remove compile_opt
;#<
;===========================================================================

pro frin_plot_part, wn, xx, wt, pl, frid, _extra=_extra

compile_opt idl2, hidden

plot, wn, xx, ps=1, symsize=0.4, xst=3, _extra=_extra, /nodata

qs = uniq( frid.detlist, sort( frid.detlist ) )
for k = 0, n_elements( qs ) - 1 do begin
  q = where( frid.detlist EQ frid.detlist[qs[k]] )
  cl = ( frid.detlist[qs[k]] MOD 10 ) + 1
  oplot, wn[q], xx[q], ps=1, symsize=0.4, color=cl, _extra=_extra
endfor
;waitforcursor

;b = where( wt GE 1, nb )
;if ( nb GT 0 ) then oplot, wn[b], xx[b], ps=1, symsize=0.4, _extra=_extra
;b = where( wt LE 0, nb )
;if ( nb GT 0 ) then oplot, wn[b], xx[b], ps=3, color=2, _extra=_extra
;b = where( wt GT 0 AND wt LT 1, nb )
;if ( nb GT 0 ) then oplot, wn[b], xx[b], ps=1, symsize=0.2, color=5, $
;			   _extra=_extra

oplot, pl.wn5, pl.fr5, color=4

return
end


