PRO fts_check_allcb_event, ev

    COMMON shareplo2,s1,s2,s3,s4,oplo,rplo,iplo,gplo,bplo
    COMMON share_n, ndata,ndrv,ndet,datatype,pktid_f,pch,ver,rstext
    COMMON share_w,draw,draw2,draw3,draw4
    COMMON share_mirubara,wn0,wcnt0,icnt,icntg,icntb,spec0,spec0g,spec0b,$
        oddinteg,oddintegg,oddintegb,cbpch,cbs,cbsg,cbsb
    COMMON share_if,vif,vifpos,vif2,vifbad
    COMMON share_mirubara2,posmae,vifmae,posato,vifato,cballch
    COMMON share_cbrange, cbok,candcb
COMMON share_mirubara_long, longposmae,longifmae,longposato,longifato

	WIDGET_CONTROL, ev.ID, GET_UVALUE=uval
  CASE uval OF
    'quit': WIDGET_CONTROL, ev.TOP, /DESTROY
      'ok': BEGIN
         cbok=1
         WIDGET_CONTROL, ev.TOP, /DESTROY
       END
     'do_again': BEGIN
         WIDGET_CONTROL, ev.TOP, /DESTROY
       END
    'clear':BEGIN
        WIDGET_CONTROL, draw, GET_VALUE=fig1
        wset,fig1
       erase
     END
    'plot': BEGIN
        oplo=0
        mirubara2plot
     END
    'oplot': BEGIN
        oplo=1
        mirubara2plot
     END
    'bothplo': BEGIN
        rplo=1
        iplo=1
        mirubara2plot
     END
    'evenplo': BEGIN
        rplo=1
        iplo=0
        mirubara2plot
     END
    'oddplo': BEGIN
	rplo=0
	iplo=1
	mirubara2plot
     END
    'gandbplo': BEGIN
	gplo=1
	bplo=1
	mirubara2plot
     END
    'goplo': BEGIN
	gplo=1
	bplo=0
	mirubara2plot
     END
    'backplo': BEGIN
	gplo=0
	bplo=1
	mirubara2plot
     END

    'SLIDE1':BEGIN
  	WIDGET_CONTROL, ev.ID, GET_VALUE = s1
	mirubara2plot
     END
    'SLIDE2':BEGIN
  	WIDGET_CONTROL, ev.ID, GET_VALUE = s2
	mirubara2plot
     END
    'SLIDE3':BEGIN
  	WIDGET_CONTROL, ev.ID, GET_VALUE = s3
	if (s3 lt s4) then candcb[0]=s3
     END
    'SLIDE4':BEGIN
  	WIDGET_CONTROL, ev.ID, GET_VALUE = s4
	if (s3 lt s4) then candcb[1]=s4
     END

  ENDCASE
END


PRO mirubara2plot
    COMMON shareplo2,s1,s2,s3,s4,oplo,rplo,iplo,gplo,bplo
    COMMON share_mirubara,wn0,wcnt0,icnt,icntg,icntb,spec0,spec0g,spec0b,$
        oddinteg,oddintegg,oddintegb,cbpch,cbs,cbsg,cbsb
    COMMON share_n, ndata,ndrv,ndet,datatype,pktid_f,pch,ver,rstext
    COMMON share_w,draw,draw2,draw3,draw4
    COMMON share_if,vif,vifpos,vif2,vifbad
    COMMON share_mirubara2,posmae,vifmae,posato,vifato,cballch
    COMMON share_cbrange, cbok,candcb
COMMON share_mirubara_long, longposmae,longifmae,longposato,longifato

	WIDGET_CONTROL, draw, GET_VALUE=fig1
	WIDGET_CONTROL, draw2, GET_VALUE=fig2
	WIDGET_CONTROL, draw3, GET_VALUE=fig3
	WIDGET_CONTROL, draw4, GET_VALUE=fig4

	Wset,fig1

	IF (oplo EQ 0) then begin
          plot, wn0, spec0[*, 0, 0, s2, s1-1], psym = -2, color = 'FFFF00'XL, position = [0.2, 0.2, 0.9, 0.9], /nodata
	erase
	endif

	axis, yaxis=0, yrange=[min(spec0[*,*,*,*,s1-1]),max(spec0[*,*,*,s1-1])],$
          ticklen = 1.0,    ygridstyle = 1, ytitle = 'raw spectrum [V/s/cm-1]', /save
	axis, xaxis=0, xrange=[min(wn0),max(wn0)],ticklen=1.0,$
		xgridstyle=1,ygridstyle=1, xtitle = 'wavenumber [cm-1]', /save

	if (rplo eq 1) then begin
		if (gplo eq 1) then oplot, wn0, spec0[*,0,0,s2,s1-1],psym=-2,color='FF00FF'XL
		if (bplo eq 1) then oplot, wn0, spec0[*,0,1,s2,s1-1],psym=-2,color='0000FF'XL
	endif

	if (iplo eq 1) then begin
	    if (gplo eq 1) then oplot, wn0, spec0[*,1,0,s2,s1-1],psym=-2,color='FFFF00'XL
  	    if (bplo eq 1) then oplot, wn0, spec0[*,1,1,s2,s1-1],psym=-2,color='FF0000'XL
	endif

	WSET,fig3
	plot,cbs,oddinteg[0,*,s1-1],xrange=[min(cbs),max(cbs)],$
		xtitle='relative optical path difference [cm]',ytitle='[(V/s/cm-1)^2*cm-1]', $
          position = [0.2, 0.2, 0.9, 0.9], /nodata
	if (gplo eq 1) then begin
		oplot,cbs,oddinteg[0,*,s1-1],psym=-4,symsize=0.5
		plots,[cballch[s1-1,0]],[min(oddinteg[0,*,s1-1])],psym=-2,color='FF00FF'XL
		plots,[cbs[s2]],[oddinteg[0,s2,s1-1]],psym=-2,color='FFFF00'XL
	endif
	if (bplo eq 1) then begin
		oplot,cbs,oddinteg[1,*,s1-1],psym=-4,symsize=0.5,color='00FFFF'XL
		plots,[cballch[s1-1,1]],[min(oddinteg[1,*,s1-1])],psym=-2,color='0000FF'XL
		plots,[cbs[s2]],[oddinteg[1,s2,s1-1]],psym=-2,color="FF0000"XL
	endif

	WSET,fig4
	plot,longposmae,longifmae[*,s1-1],xrange=[min(cbs),max(cbs)],$
		xtitle='relative optical path difference [cm]',ytitle='interferogram [V/s]', $
          position = [0.2, 0.2, 0.9, 0.9], /nodata
	if (gplo eq 1) then begin
		oplot,longposmae,longifmae[*,s1-1],psym=-4,symsize=0.5
		plots,[cballch[s1-1,0],cballch[s1-1,0]],[-10,10],psym=-2;,color='FF00FF'XL
		plots,[cbs[s2],cbs[s2]],[-10,10],psym=-2,color="FFFF00"XL
	endif
	if (bplo eq 1) then begin
		oplot,longposato,longifato[*,s1-1],psym=-4,$
			symsize=0.5,color='00FFFF'XL
		plots,[cballch[s1-1,1],cballch[s1-1,1]],[-10,10],psym=-2,color='00FFFF'XL
		plots,[cbs[s2],cbs[s2]],[-10,10],psym=-2,color="FF0000"XL
	endif

	WSET,fig2
	 xx=indgen(ndet)+1
         plot, xx, cballch[*, 0], xrange = [1, ndet], $
           yrange = [min(cballch[*, *]), max(cballch[*, *])], $
           ticklen = 1.0, xstyle = 1, xgridstyle = 1, ygridstyle = 1, $
           xtitle = 'channel', ytitle = 'relative optical path difference [cm]', xtickinterval = ndet/3, $
           position = [0.2, 0.2, 0.9, 0.9], /nodata
	 if (gplo eq 1) then begin
	 	oplot,xx,cballch[*,0],psym=-4,symsize=0.5
		plots, s1,cballch[s1-1,0],psym=-2,color='FF00FF'XL
	 	plots, s1,cbs[s2],psym=-2,color='FFFF00'XL
	 endif
	 if (bplo eq 1) then begin
	 	oplot,xx,cballch[*,1],psym=-4,symsize=0.5,color='00FFFF'XL
		 plots, s1,cballch[s1-1,1],psym=-2,color='0000FF'XL
	 	plots, s1,cbs[s2],psym=-2,color='FF0000'XL
	 endif

END


PRO fts_check_allcb
    COMMON shareplo2,s1,s2,s3,s4,oplo,rplo,iplo,gplo,bplo
    COMMON share_mirubara,wn0,wcnt0,icnt,icntg,icntb,spec0,spec0g,spec0b,$
        oddinteg,oddintegg,oddintegb,cbpch,cbs,cbsg,cbsb
     COMMON share_n, ndata,ndrv,ndet,datatype,pktid_f,pch,ver,rstext
    COMMON share_w,draw,draw2,draw3,draw4
    COMMON share_if,vif,vifpos,vif2,vifbad
    COMMON share_mirubara2,posmae,vifmae,posato,vifato,cballch
    COMMON share_cbrange, cbok,candcb
COMMON share_mirubara_long, longposmae,longifmae,longposato,longifato
   COMMON share_name,filename0,addname0, newname


	s1=pch+1
	s2=0S
        s3=candcb[0]
        s4=candcb[1]
 	oplo=0
	rplo=1
 	iplo=1
	gplo=1
	bplo=0

	base0= WIDGET_BASE(TITLE = 'check_all_cb: '+filename0, $
          row=3,XSIZE=930,YSIZE=900)
 baseT = WIDGET_BASE(base0,column=2,XSIZE=930,YSIZE=300)
	baseTL= WIDGET_BASE(baseT,/column)
	label= WIDGET_LABEL(baseTL,VALUE = 'raw spectrum')
	Draw = Widget_Draw(baseTL ,XOFFSET=5 ,YOFFSET=20,SCR_XSIZE=450 ,SCR_YSIZE=300)
  baseTR= WIDGET_BASE(baseT,/column)
	labe2= WIDGET_LABEL(baseTR,VALUE = 'selected zero-path position')
	Draw2= Widget_Draw(baseTR ,xOFFSET=20,SCR_XSIZE=450 ,SCR_YSIZE=280)

	baseB= WIDGET_BASE(base0,column=3)
	baseBL=WIDGET_BASE(baseB,row=3)
	baseBM=WIDGET_BASE(baseB,/column)
	baseBR=WIDGET_BASE(baseB,/column)

   baseBBB= WIDGET_BASE(base0,row=2)
        baseBBB1 = WIDGET_BASE(baseBBB)
        labelBBB1 = WIDGET_LABEL(baseBBB1, VALUE = 'Range of relative optical difference to determine zero-path position')
        baseBBB2 = WIDGET_BASE(baseBBB, /row)
	slider3 = CW_FSLIDER(baseBBB2, /double,MINIMUM = -0.1, MAXIMUM = 0.1, $
	   TITLE = 'minimum', /FRAME, UVALUE = 'SLIDE3',VALUE=s3,XSIZE = 300)
	slider4 = CW_FSLIDER(baseBBB2,/double, MINIMUM = -0.1, MAXIMUM = 0.1, $
	  TITLE = 'maximum', /FRAME, UVALUE = 'SLIDE4',VALUE=s4,XSIZE = 300)


	baseBLU=WIDGET_BASE(baseBL,/row)
	button1 = WIDGET_BUTTON(baseBLU, VALUE='clear', UVALUE='clear')
	button2 = WIDGET_BUTTON(baseBLU, value='ok', UVALUE='ok')
	button3 = WIDGET_BUTTON(baseBLU, value='do_again', UVALUE='do_again')

	baseBLM=WIDGET_BASE(baseBL,/column,XOFFSET=10)
	slider1 = WIDGET_SLIDER(baseBLM,	MINIMUM = 1, MAXIMUM = ndet, $
		  TITLE = 'channel', /FRAME, UVALUE = 'SLIDE1',VALUE=s1,XSIZE = 150)
	slider2 = WIDGET_SLIDER(baseBLM, MINIMUM = 0, MAXIMUM = icnt-1, $
		  TITLE = 'zero-path position', /FRAME, UVALUE = 'SLIDE2',VALUE=s2,XSIZE = 150)

	baseBLB=WIDGET_BASE(baseBL,/row)
	baseBLBL=WIDGET_BASE(baseBLB,/column, /EXCLUSIVE, XOFFSET=15)
	onbutton = WIDGET_BUTTON(baseBLBL,VALUE='oplot', UVALUE='oplot', /NO_RELEASE)
	offbutton = WIDGET_BUTTON(baseBLBL,VALUE='plot', UVALUE='plot', /NO_RELEASE)

	baseBLBM=WIDGET_BASE(baseBLB,/column,/EXCLUSIVE, XOFFSET=15)
	bobutton = WIDGET_BUTTON(baseBLBM,VALUE='both', UVALUE='bothplo')
	evbutton = WIDGET_BUTTON(baseBLBM,VALUE='real', UVALUE='evenplo')
	odbutton = WIDGET_BUTTON(baseBLBM,VALUE='imaginary', UVALUE='oddplo')

	baseBLBR=WIDGET_BASE(baseBLB,/column,/EXCLUSIVE, XOFFSET=15)
	gbbutton = WIDGET_BUTTON(baseBLBR,VALUE='both', UVALUE='gandbplo')
	gobutton = WIDGET_BUTTON(baseBLBR,VALUE='forward', UVALUE='goplo')
	bubutton = WIDGET_BUTTON(baseBLBR,VALUE='backward', UVALUE='backplo')

	labe3= WIDGET_LABEL(baseBM,VALUE = 'Integration of squared imaginary part')
	Draw3= Widget_Draw(BaseBM ,SCR_XSIZE=320 ,SCR_YSIZE=220)
	labe4= WIDGET_LABEL(baseBR,VALUE = 'Interferogram')
	Draw4= Widget_Draw(BaseBR ,SCR_XSIZE=320 ,SCR_YSIZE=220)

	WIDGET_CONTROL, offbutton, /SET_BUTTON
	WIDGET_CONTROL, bobutton, /SET_BUTTON
  WIDGET_CONTROL, gobutton, /SET_BUTTON

	WIDGET_CONTROL, base0, /REALIZE
  XMANAGER, 'fts_check_allcb', base0

END
