PRO fts_check_drivecb_event, ev

    COMMON shareplo,s1,s2,s3,s4,s5,s6,oplo,rplo,iplo,gplo,bplo
    COMMON share_n, ndata,ndrv,ndet,datatype,pktid_f,pch,ver,rstext
    COMMON share_w,draw,draw2,draw3,draw4
    COMMON share_mirubara,wn0,wcnt0,icnt,icntg,icntb,spec0,spec0g,spec0b,$
        oddinteg,oddintegg,oddintegb,cbpch,cbs,cbsg,cbsb
    COMMON share_if,vif,vifpos,vif2,vifbad
    COMMON share_cbrange, cbok,candcb

   WIDGET_CONTROL, ev.ID, GET_UVALUE=uval
   CASE uval OF
      'ok': BEGIN
         cbok=1
         WIDGET_CONTROL, ev.TOP, /DESTROY
       END
      'do_again': BEGIN
         WIDGET_CONTROL, ev.TOP, /DESTROY
       END

   'clear':BEGIN
        WIDGET_CONTROL, draw, GET_VALUE=fig1
        wset,fig1
       erase
     END
    'plot': BEGIN
        oplo=0
        mirubaraplot
     END
    'oplot': BEGIN
        oplo=1
        mirubaraplot
     END
    'bothplo': BEGIN
        rplo=1
        iplo=1
        mirubaraplot
     END
    'evenplo': BEGIN
        rplo=1
        iplo=0
        mirubaraplot
     END
    'oddplo': BEGIN
	rplo=0
	iplo=1
	mirubaraplot
     END
    'gandbplo': BEGIN
	gplo=1
	bplo=1
	mirubaraplot
     END
    'goplo': BEGIN
	gplo=1
	bplo=0
	mirubaraplot
     END
    'backplo': BEGIN
	gplo=0
	bplo=1
	mirubaraplot
     END

    'SLIDE1':BEGIN
  	WIDGET_CONTROL, ev.ID, GET_VALUE = s1
	mirubaraplot
     END
    'SLIDE2':BEGIN
  	WIDGET_CONTROL, ev.ID, GET_VALUE = s2
	mirubaraplot
     END
    'SLIDE3':BEGIN
  	WIDGET_CONTROL, ev.ID, GET_VALUE = s3
	if (s3 lt s4) then candcb[0]=s3
     END
    'SLIDE4':BEGIN
  	WIDGET_CONTROL, ev.ID, GET_VALUE = s4
	if (s3 lt s4) then candcb[1]=s4
     END
    'SLIDE5':BEGIN
  	WIDGET_CONTROL, ev.ID, GET_VALUE = s5
	if (s5 lt s6) then candcb[2]=s5
     END
    'SLIDE6':BEGIN
  	WIDGET_CONTROL, ev.ID, GET_VALUE = s6
	if (s5 lt s6) then candcb[3]=s6
     END

  ENDCASE
END


PRO mirubaraplot
    COMMON shareplo,s1,s2,s3,s4,s5,s6,oplo,rplo,iplo,gplo,bplo
    COMMON share_mirubara,wn0,wcnt0,icnt,icntg,icntb,spec0,spec0g,spec0b,$
        oddinteg,oddintegg,oddintegb,cbpch,cbs,cbsg,cbsb
    COMMON share_n, ndata,ndrv,ndet,datatype,pktid_f,pch,ver,rstext
    COMMON share_w,draw,draw2,draw3,draw4
    COMMON share_if,vif,vifpos,vif2,vifbad
    COMMON share_cbrange, cbok,candcb

	WIDGET_CONTROL, draw, GET_VALUE=fig1
	WIDGET_CONTROL, draw2, GET_VALUE=fig2
	WIDGET_CONTROL, draw3, GET_VALUE=fig3
	WIDGET_CONTROL, draw4, GET_VALUE=fig4

	Wset,fig1

	IF (oplo EQ 0) then begin
	plot, wn0, spec0g[*,0,s2,s1],psym=-2,color='FFFF00'XL,position = [0.2, 0.15, 0.9, 0.9], /nodata
	erase
	endif

	axis, yaxis=0, yrange=[min(spec0g),max(spec0g)],$
          ticklen = 1.0,    ygridstyle = 1, ytitle = 'raw spectrum [V/s/cm-1]', /save
	axis, xaxis=0, xrange=[min(wn0),max(wn0)],ticklen=1.0,$
          xgridstyle = 1, ygridstyle = 1, xtitle = 'wavenumber [cm-1]', /save

	if (rplo eq 1) then begin
		if (gplo eq 1) then oplot, wn0, spec0g[*,0,s2,s1],psym=-2,color='FF00FF'XL
		if (bplo eq 1) then oplot, wn0, spec0b[*,0,s2,s1],psym=-2,color='0000FF'XL
	endif

	if (iplo eq 1) then begin
	    if (gplo eq 1) then oplot, wn0, spec0g[*,1,s2,s1],psym=-2,color='FFFF00'XL
  	    if (bplo eq 1) then oplot, wn0, spec0b[*,1,s2,s1],psym=-2,color='FF0000'XL
	endif

	WSET,fig3
	plot,cbsg,oddintegg[*,s1],xrange=[min([cbsg,cbsb]),max([cbsg,cbsb])],$
		xtitle='relative optical path difference [cm]',ytitle='[(V/s/cm-1)^2*cm-1]', $
          position = [0.2, 0.15, 0.9, 0.9], /nodata
	if (gplo eq 1) then begin
		oplot,cbsg,oddintegg[*,s1],psym=-4,symsize=0.5
		plots,[cbpch[s1,0]],[min(oddintegg[*,s1])],psym=-2,color='FF00FF'XL
		plots,[cbsg[s2]],[oddintegg[s2,s1]],psym=-2,color='FFFF00'XL
	endif
	if (bplo eq 1) then begin
		oplot,cbsb,oddintegb[*,s1],psym=-4,symsize=0.5,color='00FFFF'XL
		plots,[cbpch[s1,1]],[min(oddintegb[*,s1])],psym=-2,color='0000FF'XL
		plots,[cbsb[s2]],[oddintegb[s2,s1]],psym=-2,color="FF0000"XL
	endif

	WSET,fig4
	plot,vifpos[0:ndata/2-1,s1],vif[0:ndata/2-1,s1,pch],$
                xrange=[-0.03,0.03],$
                ;xrange=[min([cbsg,cbsb]),max([cbsg ,cbsb])],$
		xtitle='relative optical path difference [cm]',ytitle='interferogram [V/s]', $
                  position = [0.2, 0.15, 0.9, 0.9], /nodata
	if (gplo eq 1) then begin
		oplot,vifpos[0:ndata/2-1,s1],vif[0:ndata/2-1,s1,pch],psym=-4,symsize=0.5
		plots,[cbpch[s1,0],cbpch[s1,0]],[-10,10],psym=-2;,color='FF00FF'XL
		plots,[cbsg[s2],cbsg[s2]],[-10,10],psym=-2,color="FFFF00"XL
	endif
	if (bplo eq 1) then begin
		oplot,vifpos[ndata/2:ndata-1,s1],vif[ndata/2:ndata-1,s1,pch],psym=-4,$
			symsize=0.5,color='00FFFF'XL
		plots,[cbpch[s1,1],cbpch[s1,1]],[-10,10],psym=-2,color='00FFFF'XL
		plots,[cbsb[s2],cbsb[s2]],[-10,10],psym=-2,color="FF0000"XL
	endif

	WSET,fig2
	 xx=indgen(ndrv)
	 plot,xx,cbpch[*,0],xrange=[0,ndrv-1],$
	 yrange=[min(cbpch[*,*]),max(cbpch[*,*])],$
	 	ticklen=1.0,xstyle=1,xgridstyle=1,ygridstyle=1,$
	 	xtitle='scan',ytitle='relative optical path difference [cm]',xtickinterval=ndet/5, $
           position = [0.2, 0.15, 0.9, 0.9], /nodata
	 if (gplo eq 1) then begin
	 	oplot,xx,cbpch[*,0],psym=-4,symsize=0.5
		plots, s1,cbpch[s1,0],psym=-2,color='FF00FF'XL
	 	plots, s1,cbsg[s2],psym=-2,color='FFFF00'XL
	 endif
	 if (bplo eq 1) then begin
	 	oplot,xx,cbpch[*,1],psym=-4,symsize=0.5,color='00FFFF'XL
		 plots, s1,cbpch[s1,1],psym=-2,color='0000FF'XL
	 	plots, s1,cbsb[s2],psym=-2,color='FF0000'XL
	 endif

END


PRO fts_check_drivecb
    COMMON shareplo,s1,s2,s3,s4,s5,s6,oplo,rplo,iplo,gplo,bplo
    COMMON share_mirubara,wn0,wcnt0,icnt,icntg,icntb,spec0,spec0g,spec0b,$
        oddinteg,oddintegg,oddintegb,cbpch,cbs,cbsg,cbsb
    COMMON share_n, ndata,ndrv,ndet,datatype,pktid_f,pch,ver,rstext
    COMMON share_w,draw,draw2,draw3,draw4
    COMMON share_if,vif,vifpos,vif2,vifbad
    COMMON share_cbrange, cbok,candcb
   COMMON share_name,filename0,addname0, newname



	s1=0S
	s2=0S
        s3=candcb[0]
        s4=candcb[1]
        s5=candcb[2]
        s6=candcb[3]
	oplo=0
	rplo=1
	iplo=1
	gplo=1
	bplo=0

   base0= WIDGET_BASE(TITLE = 'check_drive_cb: '+filename0,$
      row=3,XSIZE=930,YSIZE=900)
   baseT = WIDGET_BASE(base0,column=2) ;,XSIZE=930,YSIZE=300)
      baseTL= WIDGET_BASE(baseT,/column)
      label= WIDGET_LABEL(baseTL,VALUE = 'raw spectrum of channel '+strtrim(string(pch+1L), 2))
      Draw = Widget_Draw(baseTL ,XOFFSET=5 ,YOFFSET=20,SCR_XSIZE=450 ,SCR_YSIZE=280)
      baseTR= WIDGET_BASE(baseT,/column)
      labe2= WIDGET_LABEL(baseTR,VALUE = 'selected zero-path position')
      Draw2= Widget_Draw(baseTR ,xOFFSET=20,SCR_XSIZE=450 ,SCR_YSIZE=280)

   baseB= WIDGET_BASE(base0,column=3)
      baseBL=WIDGET_BASE(baseB,row=3)
      baseBM=WIDGET_BASE(baseB,/column)
      baseBR=WIDGET_BASE(baseB,/column)
   baseBBB= WIDGET_BASE(base0,row=4)
      baseBBB1 = WIDGET_BASE(baseBBB)
      baseBBB2 = WIDGET_BASE(baseBBB, /row)
      baseBBB3 = WIDGET_BASE(baseBBB)
      baseBBB4 = WIDGET_BASE(baseBBB, /row)
        labelBBB1 = WIDGET_LABEL(baseBBB1, VALUE = 'Range of relative optical difference to determine zero-path position (forward scan)', /align_center)
	slider3 = CW_FSLIDER(baseBBB2, /double,MINIMUM = -0.1, MAXIMUM = 0.1, $
	   TITLE = 'minimum', /FRAME, UVALUE = 'SLIDE3',VALUE=s3,XSIZE = 300)
	slider4 = CW_FSLIDER(baseBBB2,/double, MINIMUM = -0.1, MAXIMUM = 0.1, $
	  TITLE = 'maximum', /FRAME, UVALUE = 'SLIDE4',VALUE=s4,XSIZE = 300)
        labelBBB3 = WIDGET_LABEL(baseBBB3, VALUE  = 'Range of relative optical difference to determine zero-path position (backward scan)')
	slider5 = CW_FSLIDER(baseBBB4, /double,MINIMUM = -0.1, MAXIMUM = 0.1, $
	  TITLE = 'minumum', /FRAME, UVALUE = 'SLIDE5',VALUE=s5,XSIZE = 300)
	slider6 = CW_FSLIDER(baseBBB4,/double, MINIMUM = -0.1, MAXIMUM = 0.1, $
	  TITLE = 'maximum', /FRAME, UVALUE = 'SLIDE6',VALUE=s6,XSIZE = 300)

      baseBLU=WIDGET_BASE(baseBL,/row)
	button1 = WIDGET_BUTTON(baseBLU, VALUE='clear', UVALUE='clear')
	button2 = WIDGET_BUTTON(baseBLU, value='ok', UVALUE='ok')
	button3 = WIDGET_BUTTON(baseBLU, value='do_again', UVALUE='do_again')

      baseBLM=WIDGET_BASE(baseBL,/column,XOFFSET=10)
	slider1 = WIDGET_SLIDER(baseBLM, MINIMUM = 0, MAXIMUM = ndrv-1, $
		  TITLE = 'scan', /FRAME, UVALUE = 'SLIDE1',VALUE=s1,XSIZE = 150)
	slider2 = WIDGET_SLIDER(baseBLM, MINIMUM = 0, MAXIMUM = max([icntg , icntb])-1, $
		  TITLE = 'zero-path position', /FRAME, UVALUE = 'SLIDE2',VALUE=s2,XSIZE = 150)

      baseBLB=WIDGET_BASE(baseBL,/row)
      baseBLBL=WIDGET_BASE(baseBLB,/column, /EXCLUSIVE, XOFFSET=15)
        onbutton = WIDGET_BUTTON(baseBLBL,VALUE='oplot', UVALUE='oplot', /NO_RELEASE)
	offbutton = WIDGET_BUTTON(baseBLBL,VALUE='plot', UVALUE='plot', /NO_RELEASE)

      baseBLBM=WIDGET_BASE(baseBLB,/column,/EXCLUSIVE, XOFFSET=15)
	bobutton = WIDGET_BUTTON(baseBLBM,VALUE='both', UVALUE='bothplo')
	evbutton = WIDGET_BUTTON(baseBLBM,VALUE='real', UVALUE='evenplo')
	odbutton = WIDGET_BUTTON(baseBLBM,VALUE='imaginary', UVALUE='oddplo')

      baseBLBR=WIDGET_BASE(baseBLB,/column,/EXCLUSIVE, XOFFSET=15)
	gbbutton = WIDGET_BUTTON(baseBLBR,VALUE='both', UVALUE='gandbplo')
	gobutton = WIDGET_BUTTON(baseBLBR,VALUE='forward', UVALUE='goplo')
	bubutton = WIDGET_BUTTON(baseBLBR,VALUE='backward', UVALUE='backplo')

	labe3= WIDGET_LABEL(baseBM,VALUE = 'Integration of squared imaginary part')
	Draw3= Widget_Draw(BaseBM ,SCR_XSIZE=320 ,SCR_YSIZE=200)
	labe4= WIDGET_LABEL(baseBR,VALUE = 'Interferogram')
	Draw4= Widget_Draw(BaseBR ,SCR_XSIZE=320 ,SCR_YSIZE=200)

	WIDGET_CONTROL, offbutton, /SET_BUTTON
	WIDGET_CONTROL, bobutton, /SET_BUTTON
  WIDGET_CONTROL, gobutton, /SET_BUTTON

	WIDGET_CONTROL, base0, /REALIZE
  XMANAGER, 'fts_check_drivecb', base0

END
