FUNCTION fts_getcballch, $  
  range, apd

COMMON share_n, ndata,ndrv,ndet,datatype,pktid_f,pch,ver,rstext
COMMON share_if,vif,vifpos,vif2,vifbad
COMMON share_h, heads,tmprlcb,cb

COMMON share_mirubara,wn0,wcnt0,icnt,icntg,icntb,spec0,spec0g,spec0b,$
        oddinteg,oddintegg,oddintegb,cbpch,cbs,cbsg,cbsb
COMMON share_mirubara2,posmae,vifmae,posato,vifato,cballch
COMMON share_mirubara_long, longposmae,longifmae,longposato,longifato

cballch=dblarr(ndet,2);;;[ndet,g/b]

spec0=dblarr(wcnt0,2,2,icnt,ndet);;[wn,e/o,g/b,icnt,ndet]
oddinteg=dblarr(2,icnt,ndet)

message, 'Now calculating ...', /continue

jrange=[-range,range]

for n=0,ndet-1 do begin
  for i=0, icnt-1 do begin
    spec0[*,*,0,i,n]=justdft((longposmae[*]-cbs[i]),longifmae[*,n],jrange,0,wn0, apd)
    spec0[*,*,1,i,n]=justdft((longposato[*]-cbs[i]),longifato[*,n],jrange,0,wn0, apd)
    oddinteg[0,i,n]=total((spec0[*,1,0,i,n])^2)
    oddinteg[1,i,n]=total((spec0[*,1,1,i,n])^2)
  endfor
  minp=where(oddinteg[0,*,n] eq min(oddinteg[0,*,n]))
  cballch[n,0]=cbs[minp[0]]
  minp=where(oddinteg[1,*,n] eq min(oddinteg[1,*,n]))
  cballch[n,1]=cbs[minp[0]]
  print,'Estimate zero-path position ...', string(n+1, format = '(i2)'),'/',string(ndet, format = '(i2)')
endfor



return,cballch
MESSAGE,'FINISH.',/continue

end
