PRO fts_makecbset,mcal,vifsto,setcbp, apd


COMMON share_n, ndata,ndrv,ndet,datatype,pktid_f,pch,ver,rstext
COMMON share_if,vif,vifpos,vif2,vifbad
COMMON share_h, heads,tmprlcb,cb
COMMON share_mirubara,wn0,wcnt0,icnt,icntg,icntb,spec0,spec0g,spec0b,$
        oddinteg,oddintegg,oddintegb,cbpch,cbs,cbsg,cbsb
COMMON share_mirubara2,posmae,vifmae,posato,vifato,cballch
COMMON share_mirubara_long, longposmae,longifmae,longposato,longifato

COMMON share_cbrange, cbok,candcb
COMMON share_s, wns, shortifspec, phasepara

hike = 1
candcb=[-0.0200,0.0200,-0.0200,0.0200];cm
pitch =0.0001;cm

range=0.10;cm

if (datatype eq 'FIS_SW') then wnrange=[80,160];cm^-1
if (datatype eq 'FIS_LW') then wnrange=[50,100];cm^-1
wcnt0=wnrange[1]-wnrange[0]+1
wn0=fix(wnrange[0]+indgen(wcnt0))

if ((n_elements(mcal) lt 1) and (pktid_f eq 124) and (vifsto eq 0)) $
   then vifpos[*,0]=vifpos[*,0]-0.004

cbok=0

if (n_elements(setcbp) ge 1) then begin
   cbok = 1 

   ;;;;;;;;; read standard cbpch set

   if (setcbp eq 1) then begin
      cvsroot = GETENV('FISDR_ROOT')
      if (datatype eq 'FIS_SW') then restore, cvsroot+'/fts/fts_part1/pro/cbcb2sw.sav' else $
      if (datatype eq 'FIS_LW') then restore, cvsroot+'/fts/fts_part1/pro/cbcb2lw.sav' 

      cbpch = dblarr(ndrv,2);;[ndrv,g/b]
      if (pktid_f eq 124) then begin ;;SED
         cbpch[0, *] = cbSED[0, *]
         cbpch[1:ndrv-1, *] = rebin(cbSED[1, *], ndrv-1, 2, /sample)
         cballch = yySED
       endif else $
      if (pktid_f eq 14) then begin 
         cbpch = rebin(reform (cbfull, 1, 2), ndrv, 2, /sample)
         cballch = yyy
       endif
   endif else $

   ;;;; ijiranai

   if (setcbp eq 2) then begin
      print, 'setcbp=2'
      hike = 0
   endif

endif

;;;; calculate  cbpch and check 
while (cbok eq 0) do begin
  icntg=round((candcb[1]-candcb[0])/pitch)
  icntb=round((candcb[3]-candcb[2])/pitch)
  cbsg=candcb[0]+pitch*indgen(icntg)
  cbsb=candcb[2]+pitch*indgen(icntb)
  print,'candcb=',candcb,' icntg=',icntg, 'icntb=',icntb 
  cbpch=fts_getcbpch(range,mcal, apd)
  print,'cbok=',cbok,'candcb=',candcb
endwhile


;;;;;;;;;;;;;;;;;;cbpchhiki

if (hike  eq 1) then begin
   soroe=dblarr(ndata)
   soroe[*]=1.0
   soroe2=soroe#cbpch[*,0]
   soroe3=soroe#cbpch[*,1]
   soroe4=soroe2
   soroe4[ndata/2:ndata-1,*]=soroe3[ndata/2:ndata-1,*]
   vifpos=vifpos-soroe4
 endif


posmae=vifpos[0:ndata/2-1,*]
sortposmae=sort(posmae)
posmae=posmae[sortposmae]
vifmae=vif[0:ndata/2-1,*,*] 
vifmae=reform(vifmae,long(ndata)/2*ndrv,ndet)
vifmae=vifmae[sortposmae,*]

posato=vifpos[ndata/2:ndata-1,*]
sortposato=sort(posato)
posato=posato[sortposato]
vifato=vif[ndata/2:ndata-1,*,*]
vifato=reform(vifato,long(ndata)/2*ndrv,ndet)
vifato=vifato[sortposato,*]

posmae=float(posmae)
posato=float(posato)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;



longposmae=posmae
longifmae=vifmae
longposato=posato
longifato=vifato

fts_aposadata,longposmae,longifmae,longposato,longifato

candcb=[-0.0100,0.0100];cm

if (n_elements(setcbp) eq 0) then cbok = 0 

while (cbok eq 0) do begin
   icnt=round((candcb[1]-candcb[0])/pitch)
   cbs=candcb[0]+pitch*indgen(icnt)
 
   cballch=fts_getcballch(range, apd)
   fts_clinetemp0,cline,cballch,pch
   ;;;;;  fts_wherecballch,cline

   haba=[-0.003,0.003]

   for n=0,ndet-1 do begin
      clinehaba=where( (cbs ge cline[n,0]+haba[0]) and (cbs le cline[n,0]+haba[1]) )
      minp=where(oddinteg[0,*,n] eq min(oddinteg[0,clinehaba,n]))
      cballch[n,0]=cbs[minp[0]]
      clinehaba=where( (cbs ge cline[n,1]+haba[0]) and (cbs le cline[n,1]+haba[1]) )
      minp=where(oddinteg[1,*,n] eq min(oddinteg[1,clinehaba,n]))
      cballch[n,1]=cbs[minp[0]]
    endfor

   fts_clinetemp0,cline,cballch,pch
   fts_check_allcb
endwhile

;;;;;;;;;;;shortifspec

shortifspec=dblarr(wcnt0,3,2,ndet);;[wns,real/im/phase,g/b,ndet]
wns = wn0


if (n_elements(setcbp) ge 1) then begin
  jrange=[-range,range]
;   shortifspec[*] = 0 

   for n=0,ndet-1 do begin
      shortifspec[*,0:1,0,n] =justdft((longposmae[*]-cballch[n,0]),longifmae[*,n],jrange,0,wn0, apd)
      shortifspec[*,0:1,1,n] =justdft((longposato[*]-cballch[n,0]),longifato[*,n],jrange,0,wn0, apd)
      shortifspec[*, 2, *,n] = atan(shortifspec[*, 1, *, n],shortifspec[*, 0, *, n] )*180/!pi
   endfor

endif else begin 
   for n = 0, ndet-1 do begin
      shortifspec[*, 0:1, 0,n] = spec0[*, *, 0, where(cbs eq cballch[n, 0]), n]
      shortifspec[*, 0:1, 1,n] = spec0[*, *, 1, where(cbs eq cballch[n, 1]), n]
      shortifspec[*, 2, *,n] = atan(shortifspec[*, 1, *, n],shortifspec[*, 0, *, n] )*180/!pi
   endfor
endelse

MESSAGE,'FINISH.',/continue
end
