PRO FTS_MEANCLIP, mcal, ncantuse, bad

COMMON share_n, ndata,ndrv,ndet,datatype,pktid_f,pch,ver,rstext,quitflg
COMMON share_if,vif,vifpos,vif2,vifbad

clipdrvmax = ndrv/2
noclipdrvmin = ndrv-clipdrvmax
bad=y_bad_val_def()

;if (pktid_f eq 124) then mparam=1 else if (pktid_f eq 14) then mparam=0
if ((pktid_f eq 124) and (n_elements(mcal) lt 1)) then  mparam =1  else  mparam = 0

sigma = 0.8*sqrt(ndrv)

tmpdc = fts_avedc(ncantuse, bad, vif)
tmpavedc = reform(total(tmpdc, 1)/ndrv)

for ich = 0L, ndet-1L do begin

  if(min(vifbad[*, *, ich]) eq 1) then continue

  allsig = dblarr(ndata)
  allmedval = dblarr(ndata)
  for idata = 0L, ndata-1L do begin
    y = reform(vif2[idata, mparam:ndrv-1, ich])/reform(tmpdc[mparam:ndrv-1, ich])*tmpavedc[ich]
    yflg = reform(vifbad[idata, mparam:ndrv-1, ich])
    wnb = where(yflg ne 1, nnb)

    if (nnb ge 4) then begin
      if (nnb lt ndrv-mparam) then  y[where(yflg eq 1)] = !values.f_nan
      meanclip, y, meany, subs = subs, clipsig = sigma
      nclipped = n_elements(y)-n_elements(subs)
      if ((nclipped eq 0) or (nclipped gt clipdrvmax)) then skpix = y else skpix = y[subs]
      allmedval[idata] = median(skpix)
      mom = moment(skpix, max = 2, double = double)
 ;     if(idata eq 0) then print, skpix, mom[0], mom[1]
      allsig[idata] = sqrt(mom[1])
    endif else allsig[idata] = 0.0
  endfor

  commonsig = median(allsig[where(allsig ne 0.0)])
;  print, ich, commonsig

  for idata = 0L, ndata-1L do begin
    y = reform(vif2[idata, mparam:ndrv-1, ich])/reform(tmpdc[mparam:ndrv-1, ich])*tmpavedc[ich]
    yflg = reform(vifbad[idata, mparam:ndrv-1, ich])
    wnb = where(yflg ne 1, nnb)

    if (nnb ge 4) then begin
      wsm = where(abs(y[wnb]-allmedval[idata]) GT 10*commonsig, ct)
      if ((ct gt 0) and (nnb-ct ge noclipdrvmin)) then begin
        print, '(ch, sample number, nclipped) = ', ich+1, idata, ct
        for ict = 0L, ct-1L do begin
;          print, '   div=', abs(y[wnb[wsm[ict]]]-allmedval[idata])/commonsig
          vif2[idata, mparam+wnb[wsm[ict]], ich] = bad
          vifbad[idata, mparam+wnb[wsm[ict]], ich] = 1
        endfor
      endif
    endif

  endfor

endfor

END
