; INPUTS:
;    tsd	TSD object reference.
;    range	range in unit of sampling
;
; OUTPUTS:
;    tsd	TSD object reference.
;	 v

pro fts_rconv2,  $	;
	tsd,		$	;TSD data
	range		;range in unit of sampling
			;ramp[nsmpl, nramp, ndet]

COMMON share_n, ndata,ndrv,ndet,datatype,pktid_f,pch,ver,rstext,quitflg
COMMON share1,x,ramp100,rampall,bad,rampflag,sname, xr, a, v, rctbl, sft

si = SIZE(range)
n=si[2]
print,'number of [range]s =',n


 rampall= y_rconv(tsd, bp,  range=[range[0,0],range[1,0]],/wide)

help,rampall, sft
if (n GT 1)then begin
  for i=1,n-1 do begin
;     print,i, 'shift = ', sft

     ramp1= y_rconv(tsd, bp,range=[range[0,i],range[1,i]],/wide)
     rampall= y_concat_ramps(rampall, ramp1)
     
  endfor
endif

MESSAGE,'FINISH.',/continue
END
