PRO fts_rm_glitch_event, ev

  COMMON share_plotv,draw,s1,s2,s3,s4,s5,rg1
  COMMON share_n, ndata,ndrv,ndet,datatype,pktid_f,pch,ver,rstext,quitflg
  COMMON groupleader, base0
  COMMON rgip,rgip0,rgip1,rgip2,rgip3
  COMMON share_if,vif,vifpos,vif2,vifbad
  COMMON share_rstok,reok
  COMMON share_name,filename0,addname0, newname

  bad=-999
  WIDGET_CONTROL, ev.ID, GET_UVALUE=uval	

  CASE uval OF
    'ok': BEGIN
        reok=1
        vif=vif2
        vifbad[where(vif eq bad)]=1 
        save,vifbad,rstext,filename=newname+'_vifbad.sav'
        WIDGET_CONTROL, ev.TOP, /DESTROY
    END

    'quit': BEGIN
        quitflg=1
        WIDGET_CONTROL,ev.TOP,/DESTROY    
     END

    'save': BEGIN
        vifbad[where(vif2 eq bad)]=1 
        save,vifbad,rstext,filename=newname+'_vifbad.sav'
      END

    'range':BEGIN
	pbase = WIDGET_BASE(row=3,tab_mode=1,XSIZE=300, YSIZE=100)
	pbaseu=WIDGET_BASE(pbase, /row)
	pbasem=WIDGET_BASE(pbase, /row)
	pbaseb=WIDGET_BASE(pbase,/align_center)
	rglab0 = WIDGET_LABEL(pbaseu, VALUE = 'xrange (',xsize=50)
	rgip0 = WIDGET_TEXT(pbaseu,/EDITABLE,XSIZE = 15, YSIZE = 1,$
		  value=string(rg1[0]),uvalue='rangeok' )
	rglab1 = WIDGET_LABEL(pbaseu, VALUE = ' ,',xsize=10)
	rgip1 = WIDGET_TEXT(pbaseu,/EDITABLE,XSIZE = 15, YSIZE = 1,$
		 value=string(rg1[1]),uvalue='rangeok')
	rglab2 = WIDGET_LABEL(pbaseu, VALUE = ')',xsize=20)
	rglab3 = WIDGET_LABEL(pbasem, VALUE = 'yrange (',xsize=50)
	rgip2 = WIDGET_TEXT(pbasem,/EDITABLE,XSIZE = 15, YSIZE = 1,$
		 value=string(rg1[2]),uvalue='rangeok')
	rglab4 = WIDGET_LABEL(pbasem, VALUE = ' ,',xsize=10)
	rgip3 = WIDGET_TEXT(pbasem, /EDITABLE, XSIZE =15, YSIZE = 1,$
		 value=string(rg1[3]),uvalue='rangeok')
	rglab5 = WIDGET_LABEL(pbasem, VALUE = ')',xsize=20)
	popupbutton = WIDGET_BUTTON(pbaseb, /align_center,$
                  UVALUE = 'rangeok',VALUE = 'OK', XSIZE=30, YSIZE=20)
	WIDGET_CONTROL, base0, SENSITIVE=0
		  WIDGET_CONTROL, pbase, /REALIZE
			XMANAGER, "fts_rm_glitch", pbase, GROUP_LEADER=base0, $
			          /NO_BLOCK
     END

     'rangeok': BEGIN
	WIDGET_CONTROL, rgip0, GET_VALUE = aaa0
	WIDGET_CONTROL, rgip1, GET_VALUE = aaa1
	WIDGET_CONTROL, rgip2, GET_VALUE = aaa2
	WIDGET_CONTROL, rgip3, GET_VALUE = aaa3
	rg1=[aaa0[0],aaa1[0],aaa2[0],aaa3[0]]
	WIDGET_CONTROL, ev.top, /DESTROY
        WIDGET_CONTROL, base0, SENSITIVE=1
	checkifplot
      END

     'SLIDE1':BEGIN
        WIDGET_CONTROL, ev.ID, GET_VALUE = s1
	checkifplot
      END

     'SLIDE2':BEGIN
        WIDGET_CONTROL, ev.ID, GET_VALUE = s2
        if (s2 le s3) then checkifplot
      END

     'SLIDE3':BEGIN
        WIDGET_CONTROL, ev.ID, GET_VALUE = s3
        if (s2 le s3) then checkifplot
      END

     'SLIDE4':BEGIN
        WIDGET_CONTROL, ev.ID, GET_VALUE = s4
        if (s4 le s5) then oploif
      END

     'SLIDE5':BEGIN
        WIDGET_CONTROL, ev.ID, GET_VALUE = s5
        if (s4 le s5) then oploif
      END
     
;     'badif':BEGIN
;        vif2[*,s2:s3,s1-1]=bad
;      END
     
     'badp':BEGIN
       vif2[s4:s5,s2:s3,s1-1]=bad
      END

  ENDCASE
END


PRO oploif
  COMMON share_plotv,draw,s1,s2,s3,s4,s5,rg1
  COMMON share_n, ndata,ndrv,ndet,datatype,pktid_f,pch,ver,rstext,quitflg
  COMMON share_if,vif,vifpos,vif2,vifbad
  COMMON share_rstok,reok
  COMMON share_name,filename0,addname0, newname

  XX=indgen(ndata)
  checkifplot
  oplot,XX[s4:s5],vif2[s4:s5,s2,s1-1],psym=1,color='FFFF00'XL
  if (s3 gt s2) then begin
    for ndv=s2+1, s3 do begin
       oplot,XX[s4:s5],vif2[s4:s5,ndv,s1-1],psym=1,color='FFFF00'XL
    endfor 
  endif 

END


PRO checkifplot
  COMMON share_plotv,draw,s1,s2,s3,s4,s5,rg1
  COMMON share_n, ndata,ndrv,ndet,datatype,pktid_f,pch,ver,rstext
  COMMON share_if,vif,vifpos,vif2,vifbad
  COMMON share_rstok,reok
  COMMON share_name,filename0,addname0, newname

  WIDGET_CONTROL, draw, GET_VALUE=fig1   	
  Wset,fig1
  plot, [min(vif[*, s2, s1-1]), max(vif[*, s2, s1-1])], xrange=[rg1[0],rg1[1]],yrange=[rg1[2],rg1[3]],psym=-2, xtitle = 'sample number', ytitle = 'interferogram [V/s]', /nodata
  oplot, vif[*, s2, s1-1], color = 'FF00FF'XL, psym = -2
  oplot, vif2[*, s2, s1-1], psym = -2
  if (s3 gt s2) then begin
    for ndv=s2+1, s3 do begin
      oplot, vif[*, ndv, s1-1], color = 'FF00FF'XL, psym = -2
      oplot, vif2[*, ndv, s1-1], psym = -2
    endfor 
  endif 
END


PRO fts_rm_glitch

  COMMON share_plotv,draw,s1,s2,s3,s4,s5,rg1
  COMMON share_n, ndata,ndrv,ndet,datatype,pktid_f,pch,ver,rstext,quitflg
  COMMON groupleader, base0
  COMMON share_if,vif,vifpos,vif2,vifbad
  COMMON share_rstok,reok
  COMMON share_name,filename0,addname0, newname

  s1=1
  s2=0
  s3=0
  s4=0
  s5=0
  rg1=[0,ndata-1, 0, 1]

  base0= WIDGET_BASE(TITLE = 'rm_glitch: '+filename0,$
     /column,XSIZE=1000,YSIZE=550)
    baseT = WIDGET_BASE(base0,XSIZE=980,YSIZE=400)
;      label= WIDGET_LABEL(baseT,VALUE = 'vif')
      Draw = Widget_Draw(baseT ,XOFFSET=5 ,YOFFSET=20,XSIZE=980 ,YSIZE=350)
  
    baseB= WIDGET_BASE(base0,/row,XSIZE=950,YSIZE=50)
      button1 = WIDGET_BUTTON(baseB, value='ok', UVALUE='ok')
      button2 = WIDGET_BUTTON(baseB, value='range', UVALUE='range')

      slider1 = WIDGET_SLIDER(baseB,MINIMUM = 1, MAXIMUM = ndet, $
	  TITLE = 'channel', /FRAME, UVALUE = 'SLIDE1',VALUE=s1,XSIZE = 150)

;      button3 = WIDGET_BUTTON(baseB, value='badif', UVALUE='badif')


     baseBB = WIDGET_BASE(base0,/row)
      baseBB1 = WIDGET_BASE(baseBB, row = 2)
      baseBB2 = WIDGET_BASE(baseBB, row = 2)
      baseBB3 = WIDGET_BASE(baseBB, row = 2)

      baseBB1u = WIDGET_BASE(baseBB1)
      baseBB1b = WIDGET_BASE(baseBB1, /row)
      baseBB2u = WIDGET_BASE(baseBB2)
      baseBB2b = WIDGET_BASE(baseBB2, /row)
      baseBB3u = WIDGET_BASE(baseBB3)
      baseBB3b = WIDGET_BASE(baseBB3, /row)

      labelBB1u = WIDGET_LABEL(baseBB1u, VALUE = 'plot scan range')
      slider2 = WIDGET_SLIDER(baseBB1b,MINIMUM = 0, MAXIMUM = ndrv-1, $
	  TITLE = 'minimum', /FRAME, UVALUE = 'SLIDE2',VALUE=s2,XSIZE = 100)
      slider3 = WIDGET_SLIDER(baseBB1b,MINIMUM = 0, MAXIMUM = ndrv-1, $
	  TITLE = 'maximum', /FRAME, UVALUE = 'SLIDE3',VALUE=s3,XSIZE = 100)

      labelBB2u = WIDGET_LABEL(baseBB2u, VALUE = 'selected data range')
      slider4 = WIDGET_SLIDER(baseBB2b,MINIMUM = 0, MAXIMUM = ndata-1, $
	  TITLE = 'minimum', /FRAME, UVALUE = 'SLIDE4',VALUE=s4,XSIZE = 240)
      slider5 = WIDGET_SLIDER(baseBB2b,MINIMUM = 0, MAXIMUM =ndata-1 , $
	  TITLE = 'maximum', /FRAME, UVALUE = 'SLIDE5',VALUE=s5,XSIZE = 240)

      labelBB3u = WIDGET_LABEL(baseBB3u, VALUE = ' ')
      button4 = WIDGET_BUTTON(baseBB3b, value='mask data', UVALUE='badp')
      button5 = WIDGET_BUTTON(baseBB3b, value = 'save', UVALUE='save')
      button6 = WIDGET_BUTTON(baseBB3b, value = 'quit', UVALUE='quit')

  WIDGET_CONTROL, base0, /REALIZE
  XMANAGER, 'fts_rm_glitch', base0, GROUP_LEADER=GROUP;, ;/NO_BLOCK

END
