FUNCTION justdft, $	;spec[wcnt,2]  0:even,1:odd
                  opd,    $     ;  opd[ndata]
                  ifg,    $     ;  if[ndata]
                  range,  $     ;  range[2]=[-0.1,0.1] ;cm 
                  cb,     $     ;  cb[1]=0.0 ;cm 
                  wn,     $     ;  wn[wcnt]
                  apd     ;  apodization type

  swn = size(wn)
  wcnt = swn[1]
  opd2 = opd-cb

  spec = dblarr(wcnt, 2)
  deltal = abs((shift(opd2, -1)-shift(opd2, 1))/2)

  inr = where((opd2 GE range[0]) and (opd2 LT range[1]), ninr)

  if (ninr gt 1) then begin
  	
;; apodization

    case apd of
      'rect': apdfunc = replicate(1D, ninr)
      'tri' : begin
        if((range[0] ne range[1]*(-1)) and (range[1] ne 0)) then message, 'range should be [-a,a] or [-a,0] in triangle apodization'
        apdfunc = 1.0-abs(opd2[inr])/abs(range[0])
      end
      'hanning' : begin
        if((range[0] ne range[1]*(-1)) and (range[1] ne 0)) then message, 'range should be [-a,a] or [-a,0] in hanning apodization'
        apdfunc = 0.5+0.5*cos(!DPI*opd2[inr]/abs(range[0]))
      end
      'connes' : begin
        if((range[0] ne range[1]*(-1)) and (range[1] ne 0)) then message, 'range should be [-a,a] or [-a,0] in hanning apodization'
        apdfunc = (1.0-(opd2[inr]/abs(range[0]))^2)^2
      end

      else : message, 'uncorrect apdizing function'
    endcase

;; DFT

    if( wcnt le 20000) then begin
      for w = 0, wcnt-1 do begin
        aaa = ifg[inr]*(cos(2*!pi*opd2[inr]*wn[w])*deltal[inr])*apdfunc
        bbb = ifg[inr]*(sin(2*!pi*opd2[inr]*wn[w])*deltal[inr])*apdfunc

        spec[w, 0] = total(aaa)
        spec[w, 1] = total(bbb)

      endfor
    endif else   if( wcnt gt 20000) then begin
      for w = 0, 19999 do begin
        aaa = ifg[inr]*(cos(2*!pi*opd2[inr]*wn[w])*deltal[inr])*apdfunc
        bbb = ifg[inr]*(sin(2*!pi*opd2[inr]*wn[w])*deltal[inr])*apdfunc
        spec[w, 0] = total(aaa)
        spec[w, 1] = total(bbb)
      endfor

      for x = 0, (wcnt-1-20000) do begin
        w = long(x)+20000 
        aaa = ifg[inr]*(cos(2*!pi*opd2[inr]*wn[w])*deltal[inr])*apdfunc
        bbb = ifg[inr]*(sin(2*!pi*opd2[inr]*wn[w])*deltal[inr])*apdfunc
        spec[w, 0] = total(aaa)
        spec[w, 1] = total(bbb)
      endfor
    endif

  endif

  return, spec

END
