PRO pson, tfile, FILE=file, COLOR=color, BW=bw, PORTRAIT=portrait, LANDSCAPE=landscape
; set the output mode to ps file
; 97/10/12 can specify the output file as argument
; 98/01/15 add COLOR to make color plot
; 98/04/06 set color = 0 when /COLOR is not specified
; 03/02/26 color = 1 is default
; 06/12/08 /BW, /PORTRAIT and /LANDSCAPE (default) added

if (not keyword_set(file)) then begin
   if (n_params() GE 1) then file = tfile $
   else                      file = 'out.ps'
endif
if (keyword_set(BW)) then color = 0 else color = 1

set_plot, 'ps'

if (KEYWORD_SET(PORTRAIT)) then begin
   device, filename=file, COLOR=color, /portrait, $
      xoffset=1.095, yoffset=2.794, xsize=17.78, ysize=24.13
endif else begin
   device, filename=file, COLOR=color, /landscape
endelse

return
end
